C	plotrack.f - to read tle.new, predict when a target will be
C	visible from a given location, and make postscript star charts
C	LINK with SATSUBS and SUBS
C	unit=1 used to read tle.new
C	unit=2 used to write middle of sats.html
C	unit=3 used to write Postscript file
	CHARACTER*14 NAME,GMT,TARGET,TARG
	CHARACTER*80 ABUF1,ABUF2
	REAL*4 C(3),XYZ(3,1440),OBS(3)
	REAL*8 T,GMT2T68,TT(1440),PASS(100),TMAXEL
	REAL*4 AZ(1440),EL(1440),D(1440),SEL(1440),SSL(1440),DM(1440)
	REAL*4 LAT,LONG,MINEL,MAXSUNEL
	LOGICAL WAITING,FIRST
	REAL*4 FMTYPE
	COMMON /TYPEFM/ FMTYPE
	PARAMETER (RE=6378.140,RP=6356.755,RM=6371.0)
	PARAMETER (PI=3.14159265358979)
	PARAMETER (DTR=57.2957795130824,TWOPI=6.28318530717958)
	PARAMETER (ABSMAG=0.0)
	WRITE (*,898) 'ENTER GMT AS YYDDDHHMMSSFFF:'
898	FORMAT(A,$)
	READ (*,899) GMT
899	FORMAT(A)
	NC = 14
	DO WHILE (GMT(NC:NC).EQ.' ' .AND.NC.GT.1)
	  NC = NC-1
	ENDDO
	IF (NC.LT.14) GMT(NC+1:14) = '000000000000000000'
	T = GMT2T68(GMT)
	CALL T68_TO_GMT(T,GMT)
	WRITE (*,899) 'GMT = '//GMT
	WRITE (*,FMT='(A,F15.3)') 'T = ',T
	CALL UTC(T,IY,IMON,IDAY,IH,IM,SEC)
	IY = MOD(IY,100)
	WRITE (*,903) IMON,IDAY,IY,IH,IM,SEC
	WRITE (*,898) 'Enter TARGET:'
	READ (*,899) TARGET
	NC = 14
	DO WHILE (TARGET(NC:NC).EQ.' ' .AND.NC.GT.1)
	  NC = NC-1
	ENDDO
	IF (NC.LT.14) TARGET(NC+1:14) = '                 ' 
	WRITE (*,898) 'Enter Lat(N) and Long(W), min El, max Sun el & IFSGP:'
	READ (*,FMT='(4F10.3,I5)') LAT,LONG,MINEL,MAXSUNEL,IFSGP
	IF (IFSGP.NE.0) FMTYPE = 4HSGP 
C	defaults when missing values give zero, and enforced
C	minimums:
	MINEL = MAX(MINEL,10.)
	MAXSUNEL = MIN(-6.,MAXSUNEL)
C	adjust the time to the previous local noon, if not already in 11..13
	JH = IH - LONG/15. + 24.5
	JH = MOD(JH,24)
	IF (IABS(JH-12).GT.1) THEN
	  IF (JH.GT.12) THEN
	    T = T-3600*(JH-12)-60*IM-SEC
	  ELSE
	    T = T-3600*(JH+12)-60*IM-SEC
	  ENDIF
	  CALL T68_TO_GMT(T,GMT)
	  WRITE (*,899) 'GMT = '//GMT
	  WRITE (*,FMT='(A,F15.3)') ' T = ',T
	  CALL UTC(T,IY,IMON,IDAY,IH,IM,SEC)
	  IY = IY-1900
	  WRITE (*,903) IMON,IDAY,IY,IH,IM,SEC
	ENDIF
	OPEN (UNIT=1,FILE='tle.new',STATUS='OLD')
100	READ (1,FMT='(A)',END=666) NAME
	NC = 11
	DO WHILE (NAME(NC:NC).EQ.' ' .AND.NC.GT.1)
	  NC = NC-1
	ENDDO
	IF (NC.LT.11) NAME = NAME(1:NC)//'           '
	TARG = TARGET
C	WRITE (*,*) NAME
	IF (NAME.NE.TARG) GO TO 100
C
C	GOT IT ...
C
	FIRST = .TRUE.
	READ (1,FMT='(A)') ABUF1
	READ (1,FMT='(A)') ABUF2
	CLOSE (UNIT=1)
	WRITE (*,*) ABUF1(1:69)
	WRITE (*,*) ABUF2(1:69)
	WRITE (*,*) '    UTC at maxel         az    az''  maxel Range'
	1	,' Sunel @sat  @sat''  DM'
C	DO IM=1,1440
C	  TT(IM) = T + 600*(IM-1)
C	ENDDO
C	CALL SAT_ORBIT(ABUF1,ABUF2,1440,TT,XYZ)
C	DO IM=0,1439
C	  RMIN = SQRT(DOT(XYZ(1,IM+1),XYZ(1,IM+1)))
C	  WRITE (3,FMT='(I4,F8.1)') IM,RMIN
C	ENDDO
	DO IDY = 1,14
	  NPASS = 0
	  DO IM=1,1440
	    TT(IM) = T + 60*(IM-1) + 864.D2*(IDY-1)
	  ENDDO
	  CALL SATELLITE(ABUF1,ABUF2,1440,TT,LAT,LONG,AZ,EL,D,SEL,SSL)
	  DO I = 2,1439
	    IF (SEL(I).LT.MAXSUNEL+2. .AND. SSL(I).GT.-3.0 
	1	.AND. EL(I).GT.MAX(MINEL-5.0,EL(I-1),EL(I+1))) THEN
	      NPASS = NPASS+1
	      PASS(NPASS) = TT(I)
	    ENDIF
	  ENDDO
	  DO IPASS=1,NPASS
	    DO IS = 1,301
	      TT(IS) = PASS(IPASS) + IS - 151.D0
	    ENDDO
	    CALL SATELLITE2(ABUF1,ABUF2,301,TT,LAT,LONG,AZ,EL,D,
	1	SEL,SSL,DM)
	    IOK = 0
200	    DO I = 2,300
	      IF (SEL(I).LT.MAXSUNEL .AND. SSL(I).GT.1.0 
	1	.AND. EL(I).GT.MAX(MINEL,EL(I-1),EL(I+1))) THEN
		  IOK = 1
		  TMAXEL = TT(I)
		  RMIN = D(I)
	          CALL UTC(TT(I),IY,IMON,IDAY,IH,IM,SEC)
	          IY = IY-1900
		  DAZDT = (AZ(I+1)-AZ(I-1))/2.0
		  DSSLDT = (SSL(I+1)-SSL(I-1))/2.0
		  APPMAG = ABSMAG+DM(I)
	          WRITE (*,903) IMON,IDAY,IY,IH,IM,SEC,AZ(I),DAZDT,
	1		EL(I),D(I),SEL(I),SSL(I),DSSLDT,APPMAG
		  IF (FIRST) THEN
		    FIRST = .FALSE.
		    NCT = 14
		    DO WHILE (TARGET(NCT:NCT).EQ.' ')
		      NCT = NCT-1
		    ENDDO
		    OPEN (UNIT=2,STATUS='UNKNOWN',ACCESS='APPEND')
C	for VMS, add CARRIAGECONTROL='LIST', to the OPEN statement above
		    WRITE (2,FMT='(A)') '<H3>'
		    WRITE (2,FMT='(A)') TARGET(1:NCT)
		    WRITE (2,FMT='(A)') '</H3><PRE>'
		    WRITE (2,FMT='(A)')
	1	'    UTC at maxel         az    az''  maxel Range'//
	2	' Sunel @sat  @sat''  DM'
		  ENDIF
	          IYP = MOD(IY,100)
	          WRITE (GMT,FMT='(4I2)') IYP,IMON,IDAY,IH
	          DO IC=1,8
	            IF (GMT(IC:IC).EQ.' ') GMT(IC:IC) = '0'
	          ENDDO
	          WRITE (2,9032)
	1	'<A HREF="./'//TARGET(1:NCT)//'/'//GMT(1:8)//'.ps">',
	2		IMON,IDAY,IY,IH,IM,SEC,AZ(I),DAZDT,
	3		EL(I),D(I),SEL(I),SSL(I),DSSLDT,APPMAG,'</A>'
	      ENDIF
	    ENDDO	! I=2,300
	    IF (IOK.EQ.1) THEN
	      DLT = 6
	      IF (RMIN.LT.960.0) DLT = 3
	      IF (RMIN.LT.480.0) DLT = 1.5
	      DO IS = 1,401
	        TT(IS) = TMAXEL + DLT*(IS-201)
	      ENDDO
	      IDLT = 10*DLT+0.5
	      CALL SAT_ORBIT(ABUF1,ABUF2,401,TT,XYZ)
	      CALL SATELLITE2(ABUF1,ABUF2,401,TT,LAT,LONG,AZ,EL,D,
	1	SEL,SSL,DM)
	      CALL PS_STARS(TMAXEL,IDLT,LAT,LONG)
	      WAITING = .TRUE.
	      DO IS=1,401
	        SIDTIM=GST(TT(IS))
C	get coordinates of observer
	        TL = TAN(LAT/DTR)
	        OBS(2) = RE/SQRT(1.+(RP*TL/RE)**2)
	        OBS(3) = TL*OBS(2)*(RP/RE)**2
	        OBS(1) = COS(SIDTIM-LONG/DTR)*OBS(2)
	        OBS(2) = SIN(SIDTIM-LONG/DTR)*OBS(2)
	        IF(.NOT.WAITING.AND.(EL(IS).LT.0.OR.SSL(IS).LT.0))THEN
	          CALL TRACK(C,' LP')
	          GO TO 250
	        ENDIF
	        DO I=1,3
	          C(I) = XYZ(I,IS)-OBS(I)
	        ENDDO
	        IF (EL(IS).GT.0. .AND. SSL(IS).GT.0. .AND. WAITING) THEN
	          WAITING = .FALSE.
	          CALL TRACK(C,' FP')
	        ENDIF
	        IF (EL(IS).GT.0. .AND. SSL(IS).GT.0. .AND.
	1		MOD(IS,10).EQ.1) THEN
		  IF (ABS(IS-201).LE.10) THEN
	            CALL TRACK(C,' AH')
	          ELSE
	            CALL TRACK(C,' DT')
	          ENDIF
	        ENDIF
	      ENDDO	! IS=1,401
250	      CALL ENDPSPLT
	    ELSE IF (IOK.EQ.0) THEN
	      IOK = 2
	      DO I=1,301
	        IF (SSL(I).LT.1.0) EL(I) = 0.
	      ENDDO
	      GO TO 200
	    ENDIF	! IF (IOK)
	  ENDDO		! IPASS=1,NPASS
	ENDDO		! IDY=1,14
	WRITE (2,FMT='(A)') '</PRE>'
	STOP
903	FORMAT(I3,1H/,I2,1H/,I2,I3,1H:,I2,1H:,F5.2,F8.1,F6.1,F6.1,
	1	F7.1,F6.1,F5.1,F7.3,F5.1)
9032	FORMAT(A,I2,1H/,I2,1H/,I2,I3,1H:,I2,1H:,F5.2,F8.1,F6.1,F6.1,
	1	F7.1,F6.1,F5.1,F7.3,F5.1,A)
904	FORMAT(3F8.1,I3,1H/,I2,1H/,I2,I3,1H:,I2,1H:,F5.2,F8.1,3F5.1)
666	WRITE (*,*) TARGET,' NOT FOUND'
	END

	SUBROUTINE PS_STARS(TMAXEL,IDLT,LAT,LONG)
C	starts a Postscript file with a star map
C	the file name is `yymmddhh.ps' based on TMAXEL
C	end the file by calling ENDPSPLT
	REAL*8 TMAXEL	! seconds since 24-May-68
	INTEGER IDLT	! seconds per dot on satellite track for caption
	REAL*4 LAT, LONG	! in degrees, + = N and W
	CHARACTER*14 GMT	! used for filename construction
	CHARACTER*36 MONTHS	! names of the months
	CHARACTER*2 CMD		! a Postscript command
	CHARACTER*80 OUTLINE	! buffer for stars
	CHARACTER*11 STAR	! 1 star
	REAL*4 S(3),C(3),SUN(3),PM(3,3)	! unit vectors and rotation matrices
	COMMON /MATRIX/ A(3,3),IPSLUN
	PARAMETER (NSTAR=174, DTR = 57.2957795130824)
	INTEGER PSCX,PSCY,PSR	! center and radius of plot in points
	PARAMETER (PSCX=306,PSCY=396,PSR=250,SUNSZ=0.04)
	INTEGER IPSIZE(9)/32,20,5,6,5,1,1,6,10/	! sizes of planets
	REAL*4 XX(24),YY(24)	! used for outline of Moon
C  16384*[cos(ra)cos(dec),sin(ra)cos(dec),sin(dec)] and 10**(2-Mag/2.5)
C  for stars brighter than V = 3 in the 1985 Astronomical Ephemeris
	INTEGER XYZM(4,NSTAR)/
	1 14351,363,7896,14,8466,241,14025,12,15815,736,4214,7,
	1 3518,362,-15997,7,11998,1251,-11085,11,8976,1488,13624,12,
	1 15309,2774,-5133,15,7860,1875,14252,10,12796,3847,9480,14,
	1 7671,2889,14185,8,244,125,16381,15,8046,3576,-13816,65,
	1 13548,7194,5754,8,6748,3787,-14440,7,10507,6116,10982,12,
	1 12893,7774,6461,15,13528,9195,-916,6,8935,8681,-10641,6,
	1 11575,11541,1112,9,6886,6956,13138,6,8584,8960,10697,14,
	1 6787,8142,12492,19,8345,12431,6651,7,7436,11783,8618,7,
	1 6547,10736,10502,6,8218,13636,-3866,6,5820,14599,4628,45,
	1 3914,13157,8944,8,3144,11409,11330,6,3851,15856,-1470,7,
	1 3361,15861,-2353,89,2320,11153,11774,92,2656,16066,1799,22,
	1 2305,14203,7834,21,2257,15149,-5817,7,2177,16238,-95,12,
	1 2000,15465,-5023,9,1916,16182,-1695,7,1877,16272,-352,20,
	1 1552,16300,-562,19,1309,13503,-9185,8,1029,16117,-2756,14,
	1 534,16238,2110,63,209,11594,11574,17,209,13046,9908,8,
	1 -1314,15075,6280,7,-1392,15525,-5043,16,-988,9886,-13027,194,
	1 -2378,15532,4637,16,-2629,14591,6971,6,-2922,15421,-4696,383,
	1 -2195,10175,-12652,6,-3509,13907,-7918,25,-4193,14075,-7262,18,
	1 -4225,12382,-9861,8,-5015,13393,-7994,10,-5837,15120,2390,6,
	1 -5395,12804,8681,46,-6677,14883,1526,70,-6232,13032,7729,34,
	1 -6374,10841,-10500,12,-5858,9468,-12019,19,-4835,6811,-14094,18,
	1 -6216,7194,-13342,16,-8664,8211,-11221,13,-4272,3825,-15347,21,
	1 -6350,5532,-14053,12,-7250,6053,-13387,10,-12644,10136,-2404,16,
	1 -12372,8422,6665,6,-5806,3848,-14829,6,-14062,7659,3465,28,
	1 -13865,6670,5628,33,-6729,2410,-14742,7,-10140,3461,-12394,8,
	1 -8688,2375,13686,11,-7430,1968,14468,19,-14974,3219,5817,9,
	1 -15422,3305,4434,4,-15809,932,4199,13,-9629,369,13250,10,
	1 -10430,-261,-12632,9,-8555,-466,-13965,7,-8834,-500,13788,4,
	1 -15619,-902,-4862,9,-7443,-775,-14575,38,-15619,-1866,-4581,6,
	1 -8894,-1107,-13715,22,-14923,-2081,-6433,8,-5843,-877,-15281,8,
	1 -10662,-1819,-12305,13,-16142,-2781,-336,7,-8177,-1618,-14104,31,
	1 -8875,-2042,13619,19,-12456,-2972,10219,6,-15528,-4137,3190,7,
	1 -12427,-4386,-9734,7,-8762,-3273,13451,17,-15055,-5670,-3098,40,
	1 -8950,-4018,-13121,12,-9519,-4723,12470,18,-9848,-5258,-11990,9,
	1 -7061,-4087,-14207,57,-11351,-6801,-9660,14,-12909,-8490,5448,103,
	1 -9593,-7516,-10950,11,-6247,-5055,-14277,94,-8575,-7106,-12016,12,
	1 -11039,-9495,7510,10,-11708,-10552,-4470,7,-3245,-2995,15777,14,
	1 -8656,-8304,-11160,8,-10700,-12127,-2619,9,-3975,-4501,-15243,6,
	1 -8765,-11692,7407,12,-9230,-13405,1878,8,-3938,-6224,-14634,7,
	1 -7596,-12619,-7175,6,-7719,-13023,-6264,11,-7566,-13445,-5514,8,
	1 -7441,-14560,-1019,8,-6359,-13354,-7046,6,-3188,-7102,14415,8,
	1 -5835,-13475,-7265,41,-5948,-14024,6030,7,-5368,-13416,-7720,7,
	1 -5878,-15000,-2976,9,-4803,-13086,8608,7,-1932,-5561,-15289,17,
	1 -4249,-12866,-9210,12,-3581,-15363,-4423,10,-1566,-9150,-13500,7,
	1 -1850,-12908,-9918,8,-1336,-9921,12970,7,-1471,-10463,-12521,6,
	1 -1694,-12962,-9876,22,-1371,-11910,-11167,17,-1906,-15875,3572,14,
	1 -1163,-12678,-10312,10,-1352,-16275,1310,7,-202,-10198,12821,12,
	1 159,-14126,-8297,6,1102,-14167,-8155,8,1228,-13460,-9259,18,
	1 1602,-14706,-7041,7,1958,-12628,10252,97,2692,-14341,-7449,5,
	1 3312,-14301,-7274,15,3640,-13720,-8180,9,3985,-13941,-7628,4,
	1 4326,-15312,3904,6,4391,-14640,-5899,6,5467,-13414,7654,5,
	1 5051,-10424,11586,7,7054,-14483,2982,8,7374,-14417,2489,49,
	1 6433,-11788,9385,2,5186,-7291,-13724,16,7208,-10253,10552,13,
	1 7423,-8868,11605,31,8942,-10269,9110,10,5764,-4949,14516,10,
	1 12885,-9983,-1653,6,13300,-9164,2745,11,13044,-8774,-4614,7,
	1 14301,-7991,-161,6,9761,-5349,-12022,20,7234,-3564,-14261,7,
	1 10466,-3824,-12011,14,13352,-4816,8181,6,13635,-3980,-8164,34,
	1 14019,-3667,7644,10,15330,-3945,4222,10,6489,3407,14653,5/
C
	MONTHS = 'JanFebMarAprMayJunJulAugSepOctNovDec'
	CALL T68_TO_UTC(TMAXEL,IY,MON,IDAY,IH,IM,SEC)
	IYP = MOD(IY,100)
	WRITE (GMT,FMT='(4I2)') IYP,MON,IDAY,IH
	DO I=1,8
	  IF (GMT(I:I).EQ.' ') GMT(I:I) = '0'
	ENDDO
	IPSLUN = 3
	OPEN(UNIT=IPSLUN,FILE=GMT(1:8)//'.ps',STATUS='UNKNOWN')
C	for VMS, add CARRIAGECONTROL='LIST', to the OPEN statement above
C	set up for precession to current of date
	CALL GET_EPOCH(TMAXEL,EPOCH)
C	fudge epoch since star positions are 1985.5 and PREMAT uses 2000
	EPOCH = EPOCH+14.5
	CALL PREMAT(EPOCH,PM)
	DO I=1,3
	  PM(I,I) = PM(I,I)+1.
	ENDDO
C	set up matrix for celestial to topocentric conversion
	SIDTIM = GST(TMAXEL) - LONG/DTR
	CT = COS(SIDTIM)
	ST = SIN(SIDTIM)
	DO I=1,3
	  DO J=1,3
	    A(I,J) = 0.
	  ENDDO
	ENDDO
C	A will be a matrix such that A*C = (S,E,up)
	A(3,3) = 1.
	A(1,1) = CT
	A(2,2) = CT
	A(1,2) = +ST
	A(2,1) = -ST
	CL = COS(LAT/DTR)
	SL = SIN(LAT/DTR)
	DO J=1,3
	  TMP = SL*A(1,J) - CL*A(3,J)
	  A(3,J) = SL*A(3,J) + CL*A(1,J)
	  A(1,J) = TMP
	ENDDO
	WRITE (IPSLUN,9) '%!PS-Adobe-1.0'
	WRITE (IPSLUN,9) '%%DocumentFonts Helvetica'
	WRITE (IPSLUN,9) '%%BoundingBox: 35 85 577 667'
	WRITE (IPSLUN,9) '%%Pages: 1'
	WRITE (IPSLUN,9) '%%EndComments'
	WRITE (IPSLUN,9) '%%Page: 1 1'
	WRITE (IPSLUN,9) '/NP {newpath} def /S {stroke} def'//
	1	' /M {moveto} def /L {lineto} def'
C	macro to plot a star as a filled circle
	WRITE (IPSLUN,9) '/p {NP 0 360 arc fill} def'
	WRITE (IPSLUN,9) '/doline {NP M L S} def'
C	macros for satellite track
	WRITE (IPSLUN,9) '/FP {/oy exch def /ox exch def} def'
	WRITE (IPSLUN,9) '/LP {NP ox oy M L S} def'
	WRITE (IPSLUN,9) '/tk {/sz exch def /ny exch def'
	1	//' /nx exch def'
	WRITE (IPSLUN,9) ' /rr nx ox sub dup mul ny oy sub '
	1	//'dup mul add 0.0001 add sqrt def'
	WRITE (IPSLUN,9) ' /dx nx ox sub rr div sz mul def'
	WRITE (IPSLUN,9) ' /dy ny oy sub rr div sz mul def'
	WRITE (IPSLUN,9) ' NP ox oy M nx ny L S '
	1	//'NP nx ny 2 0 360 arc fill'
	WRITE (IPSLUN,9) ' NP nx ny M'
	WRITE (IPSLUN,9) ' dy dx sub dx dy add -1 mul rlineto S'
	WRITE (IPSLUN,9) ' NP nx ny M'
	WRITE (IPSLUN,9) ' dx dy add -1 mul dx dy sub rlineto S'
	WRITE (IPSLUN,9) ' /ox nx def /oy ny def} def'
	WRITE (IPSLUN,9) '/DT {0 tk} def /AH {5 tk} def'
C	show a centered string:
	WRITE (IPSLUN,9) '/cshw { dup stringwidth pop -0.5 mul 0 '
	1	//'rmoveto show } def'
	WRITE (IPSLUN,FMT='(A,I3,I4,A,I5,A)')
	1	'/lbl {gsave ',pscx,pscy,' translate rotate 0 ',
	2	(-(psr+17)),' moveto cshw grestore} def'
	WRITE (IPSLUN,9) '/hrzn { (S) 0 lbl (SW) 45 lbl (W) 90 lbl '
	1	//'(NW) 135 lbl (N) 180 lbl'
	WRITE (IPSLUN,9) '(NE) 225 lbl (E) 270 lbl (SE) 315 lbl } def'
	WRITE (IPSLUN,9) '/Helvetica findfont 18 scalefont setfont'
C	label the directions on the horizon
	WRITE (IPSLUN,9) 'hrzn'
	ISEC = SEC+0.5
C	write the caption
	WRITE (IPSLUN,900) PSCX,LAT,LONG,IDAY,MONTHS(3*MON-2:3*MON),IYP,
	1	IH,IM,ISEC,IDLT
9	FORMAT(A)
900	FORMAT(I3,' 91 M (Lat,long=',F5.1,F6.1,' at UTC:',
	1	I3,1H-,A,1H-,I2,I3,1H:,I2,1H:,I2,I3,
	2	' sec/dot) cshw')
	WRITE (IPSLUN,901) PSCX,PSCY,PSR
C	draw the boundary, then use it as a clipping path:
901	FORMAT('gsave NP',3I4,' 0 360 arc gsave S grestore clip')
902	FORMAT(I3,I4,A)
	NC = 0
	DO I=1,NSTAR
	  AM = -2.5*ALOG10(XYZM(4,I)/100.0)
	  IF (AM.LT.4.0) THEN
	    DO J=1,3
	      S(J) = XYZM(J,I)
	    ENDDO
	    CALL MAV(PM,S,C)	! precess to current
	    CALL NORM(C)	! normalize
	    CALL MAV(A,C,S)	! conver to topocentric
C	stereographic mapping of hemisphere to unit circle
	    X = -S(2)/(1.+S(3))
	    Y = -S(1)/(1.+S(3))
	    IF (X*X+Y*Y.LE.1.0) THEN
	      IX = PSCX+PSR*X+0.5		! E to the left
	      IY = PSCY+PSR*Y+0.5		! S is down
	      ISZ = 5-AM
	      WRITE (STAR,FMT='(I3,I4,I2,A)') IX,IY,ISZ,' p'
	      IF (NC.GT.66) THEN
	        WRITE (IPSLUN,FMT='(A)') OUTLINE(1:NC)
	        OUTLINE = STAR
	        NC = 11
	      ELSE
	        IF (NC.GT.0) THEN
	          OUTLINE = OUTLINE(1:NC)//' '
	          NC = NC+1
	        ENDIF
	        OUTLINE = OUTLINE(1:NC)//STAR
	        NC = NC+11
	      ENDIF
	    ENDIF
	  ENDIF
	ENDDO
	IF (NC.GT.0) WRITE (IPSLUN,FMT='(A)') OUTLINE(1:NC)
903	FORMAT(I3,I4,I3,A)
904	FORMAT(I3,3I4,A)
C	planets
	WRITE (IPSLUN,9) '% planets'
	DO IP = 1,9
	  CALL T_EPHEM(IP-2,TMAXEL,C)
	  CALL NORM(C)
	  CALL MAV(A,C,S)
	  IF (IP.EQ.1) THEN
	    DO J=1,3
	      SUN(J) = S(J)
	    ENDDO
	  ENDIF
	  X = -S(2)/(1.+S(3))
	  Y = -S(1)/(1.+S(3))
	  IF (X*X+Y*Y.LE.1.0) THEN
	    IX = PSCX+PSR*X+0.5
	    IY = PSCY+PSR*Y+0.5
	    IF (IP.NE.1) THEN
C	find direction toward Sun for this planet
	      DO J=1,3
	        C(J) = S(J)+0.05*SUN(J)
	      ENDDO
	      CALL NORM(C)
	      DX = -C(2)/(1.+C(3)) - X
	      DY = -C(1)/(1.+C(3)) - Y
	      RR = SQRT(DX*DX+DY*DY)
	      DX = SUNSZ*DX/RR
	      DY = SUNSZ*DY/RR
	    ENDIF
	    IF (IP.EQ.1) THEN
C	Sun
	      ISZ = SUNSZ*PSR+0.5
	      WRITE (IPSLUN,903) IX,IY,ISZ,' NP 0 360 arc S'
	    ELSE IF (IP.EQ.2) THEN
C	Moon
	      PHASE = -DOT(SUN,S)
	      XX(1) = X+DY
	      YY(1) = Y-DX
	      XX(13) = X-DY
	      YY(13) = Y+DX
	      DO I=1,11
	        F = (I/6.0)-1.0
	        FF = SQRT(1.0-F*F)
	        XX(I+1) = X-F*DY+FF*DX
	        YY(I+1) = Y+F*DX+FF*DY
	        XX(I+13) = X+F*DY-PHASE*FF*DX
	        YY(I+13) = Y-F*DX-PHASE*FF*DY
	      ENDDO
	      CMD = ' M'
	      WRITE (IPSLUN,9) 'NP'
	      DO I=1,24
	        X = PSCX+PSR*XX(I)
	        Y = PSCY+PSR*YY(I)
	        WRITE (IPSLUN,FMT='(F5.1,F6.1,A)') X,Y,CMD
	        CMD = ' L'
	      ENDDO
	      WRITE (IPSLUN,9) 'closepath S'
	    ELSE IF (IP.EQ.4) THEN
C	Jupiter
	      X1 = PSCX+PSR*X
	      Y1 = PSCY+PSR*Y
	      ISZ = SUNSZ*PSR/1.5+0.5
	      WRITE (IPSLUN,FMT='(F5.1,F6.1,I2,A)') 
	1		X1,Y1,ISZ,' NP 0 360 arc S'
	      X1 = PSCX+PSR*(X+0.1725*DY+0.6439*DX)
	      Y1 = PSCY+PSR*(Y-0.1725*DX+0.6439*DY)
	      X2 = PSCX+PSR*(X+0.1725*DY-0.6439*DX)
	      Y2 = PSCY+PSR*(Y-0.1725*DX-0.6439*DY)
	      WRITE (IPSLUN,FMT='(F5.1,3F6.1,A)') X1,Y1,X2,Y2,' doline'
	      X1 = PSCX+PSR*(X-0.1725*DY+0.6439*DX)
	      Y1 = PSCY+PSR*(Y+0.1725*DX+0.6439*DY)
	      X2 = PSCX+PSR*(X-0.1725*DY-0.6439*DX)
	      Y2 = PSCY+PSR*(Y+0.1725*DX-0.6439*DY)
	      WRITE (IPSLUN,FMT='(F5.1,3F6.1,A)') X1,Y1,X2,Y2,' doline'
	    ELSE IF (IP.EQ.5) THEN
C	Saturn
	      ISZ = SUNSZ*PSR/2.0+0.5
	      WRITE (IPSLUN,903) IX,IY,ISZ,' NP 0 360 arc S'
	      IX1 = PSCX+PSR*(X+DX)+0.5
	      IY1 = PSCY+PSR*(Y+DY)+0.5
	      IX2 = PSCX+PSR*(X-DX)+0.5
	      IY2 = PSCY+PSR*(Y-DY)+0.5
	      WRITE (IPSLUN,904) IX1,IY1,IX2,IY2,' doline'
	    ELSE
C	just do an open circle
	      WRITE (IPSLUN,903) IX,IY,IPSIZE(IP),
	1	' 0 360 NP arc S'
	    ENDIF
	  ENDIF
	ENDDO
	RETURN
	END

	SUBROUTINE ENDPSPLT
	COMMON /MATRIX/ A(3,3),IPSLUN
	WRITE (IPSLUN,FMT='(A)') 'grestore showpage'
	CLOSE (UNIT=IPSLUN)
	RETURN
	END

	SUBROUTINE TRACK(C,CMD)
	REAL*4 C(3),S(3)
	CHARACTER*3 CMD
	COMMON /MATRIX/ A(3,3),IPSLUN
	PARAMETER (PSCX=306,PSCY=396,PSR=250)
	CALL MAV(A,C,S)
	CALL NORM(S)
	X = -S(2)/(1.+S(3))
	Y = -S(1)/(1.+S(3))
	IX = PSCX+PSR*X+0.5		! E to the left
	IY = PSCY+PSR*Y+0.5		! S is down
	WRITE (IPSLUN,FMT='(I3,I4,A)') IX,IY,CMD
	RETURN
	END

	SUBROUTINE T_EPHEM(N,T,P)
C
C	EPHEMERIS ROUTINE FOR PS_STARS
C	INPUT N INTEGER*4 PLANETS NUMBER
C		-1 FOR SUN
C		0 FOR MOON
C		1 FOR MARS
C		2 FOR JUPITER
C		3 FOR SATURN
C		4 FOR URANUS
C		5 FOR NEPTUNE
C		6 FOR MERCURY
C	        7 FOR VENUS
C
C	INPUT T REAL*8 TIME SINCE 5/24/68 0 HOURS UTC
C
C	OUTPUT VECTOR P, REAL*4 P(3)
C		DIRECTION OF P IS GEOCENTRIC POSITION OF PLANET
C		IN CELESTIAL COORDINATE SYSTEM WITH EPOCH 2000
C		MAGNITUDE IS DISTANCE IN AU EXCEPT FOR MOON IN EARTH RADII
C
C	Based on Van Flandern & Pulkinnen, 1979, Ap.J.Supp. v. 41, pp. 391-411
C	Only the heliocentric series for PLON, BETA and RP are used.
C	The U, V, W series have been deleted for compactness.
C
	INTEGER*4 N
	REAL*4 P(3),PE(3),SE(3),CONST(33),DBAR(10),STR,PRECES(3,3)
	REAL*8 T,TT,TTT,BETA,RP,PLON,ARGS(33),U,V,W,SLOPES(33)
	REAL*8 JD,JULIAN_DAY,CYCLES,TOLD
	DATA TOLD/-1.D20/
	COMMON /FMCMMN/ PLON,U,V,W,ARGS
	PARAMETER (PI=3.1415927,TWOPI=6.2831853,DTR=57.29578)
	DATA CONST/.606434,.374897,.259091,.827362,.347343,0.,
	1   .779072,.993126,.700695,.485541,.566441,.505498,
	2   .140023,.292498,.987353,.053856,.849694,.089608,
	3   .056531,.814794,.133295,.882987,.821218,.870169,
	4   .400589,.664614,.846912,.725368,.480856,0.,
	5   .663854,.041020,.357335/
	DATA SLOPES/.3660110129D-1,.3629164709D-1,.367481952D-1,
	1   .3386319198D-1,-.14709391D-3,0.D0,		!Moon
	2   .273790931D-2,.27377785D-2,			!Sun
	3   .11367714D-1,.1136759566D-1,.1136762384D-1,	!Mercury
	4   .445046867D-2,.445036173D-2,.445040017D-2,	!Venus
	5   .145575328D-2,.145561327D-2,.145569465D-2,	!Mars
	6   3*.23080893D-3,				!Jupiter???
	7   3*.9294371D-4,				!Saturn???
	8   2*.3269438D-4,.3265562D-4,			!Uranus
	9   2*.1672092D-4,.1663715D-4,	!Neptune fixed 9/21/92
	9   0.D0,.1115482D-4,2*.1104864D-4/		!Pluto
	DATA DBAR/1.00021,60.40974,1.83094,	!Sun, Moon, Mars
	1   5.30693,9.61711,19.24877,30.08900,	!Jupiter,Saturn,Uranus,Neptune
	2   41.3268,1.07693,1.23437/		!Pluto,Mercury,Venus
C
C
C	COMPUTE ARGUMENTS
C
	IF(DABS(T-TOLD).LE.1.E-2) GO TO 150
	STR=3600.*DTR
	CCC=86400.*2.9975E10/1.49E13		!Speed of light in AU/day
	JD=JULIAN_DAY(T)
	TT=JD-2451545.D0			!Days since J2000.0
	TTT=TT/36525.D0+1.D0			!Centuries since 1900.0
	EPOCH=1900.0+100.0*TTT
	CALL PREMAT(EPOCH,PRECES)
	DO 100 I=1,33
	CYCLES=CONST(I)+SLOPES(I)*TT
100	ARGS(I)=TWOPI*DMOD(CYCLES,1.D0)
	TOLD=T
C	
C	CALL APPROPRIATE ROUTINE
C
150	DO 152 I=1,3
	   PE(I)=0.				
152	   SE(I)=0.
	IF(N.NE.0) THEN
	   CALL SUN(BETASUN,RP,TTT)		
	   SUNLON=ARGS(7)+PLON/STR		
	   SE(1)=COS(SUNLON)*RP
	   SE(2)=SIN(SUNLON)*RP
	   ENDIF
	IF(N.EQ.-1) GO TO 200			
	IF(N.EQ.0) THEN
	   CALL MOONVF(BETA,RP,TTT)
	   NL=1
	   ENDIF
	IF(N.EQ.1) THEN
	   CALL MARS(BETA,RP,TTT)
	   NL=15
	   ENDIF
	IF(N.EQ.2) THEN
	   CALL JUPITER(BETA,RP,TTT)
	   NL=18
	   ENDIF
	IF (N.EQ.3) THEN
	   CALL SATURN(BETA,RP,TTT)
	   NL=21
	ENDIF
	IF (N.EQ.4) THEN
	   CALL URANUS(BETA,RP,TTT)
	   NL=24
	ENDIF
	IF (N.EQ.5) THEN
	   CALL NEPTUNE(BETA,RP,TTT)
	   NL=27
	ENDIF
	IF (N.EQ.6) THEN
	   CALL MERCURY(BETA,RP,TTT)
	   NL = 9
	ENDIF
	IF (N.EQ.7) THEN
	   CALL VENUS(BETA,RP,TTT)
	   NL = 12
	ENDIF
	IF (N.GT.7) STOP 'N TOO HIGH IN T_EPHEM'
	IF(N.LT.-1) STOP 'N TOO LOW IN T_EPHEM'
C
	PLONG=ARGS(NL)+PLON/STR
	BRAD=BETA/STR
C
C	Compute heliocentric vector in ecliptic coordinates
C
	PE(3)=RP*SIN(BRAD)			
	PE(2)=RP*COS(BRAD)			
	PE(1)=PE(2)*COS(PLONG)
	PE(2)=PE(2)*SIN(PLONG)
200	DO 220 I=1,3
220	   PE(I)=PE(I)+SE(I)			!add in Sun to get geocentric
250	EPS=(84428.-47.*TTT+9.*COS(ARGS(5)))/STR
	CEPS=COS(EPS)
	SEPS=SIN(EPS)
	DLAM=-17.*SIN(ARGS(5))/STR	!accurate conversion to celestial
	P(1)=PE(1)-DLAM*PE(2)
	PE(2)=PE(2)+DLAM*PE(1)
	P(2)=PE(2)*CEPS-PE(3)*SEPS
	P(3)=PE(3)*CEPS+PE(2)*SEPS
	RETURN
	END

	SUBROUTINE MERCURY(BETA,RP,T)
C
C	MERCURY CODE
C
	IMPLICIT REAL*8 (A-H,L,O-Z)
	IMPLICIT INTEGER*4 (I-K,M-N)
	COMMON /FMCMMN/ PLON,U,V,W,A1,A2,A3,A4,A5,A6,A7,A8,A9,
	1   A10,A11,A12,A13,A14,A15,A16,A17,A18,A19,A20,A21,A22,A23,
	1   A24,A25,A26,A27,A28,A29,A30,A31,A32,A33
	PLON = 84378.0*SIN(A10)+10733*SIN(2*A10)+1892*SIN(3*A10)
	1	-646*SIN(2*A11)+381*SIN(4*A10)-306*SIN(A10-2*A11)
	2	-274*SIN(A10+2*A11)-92*SIN(2*A10+2*A11)+83*SIN(5*A10)
	BETA = 24134*SIN(A11)+5180*SIN(A10-A11)+4910*SIN(A10+A11)
	1	+1124*SIN(2*A10+A11)+271*SIN(3*A10+A11)+132*SIN(2*A10-A11)
	RP = 0.39528-0.07834*COS(A10)-0.00795*COS(2*A10)
	1	-0.00121*COS(3*A10)-0.00022*COS(4*A10)
	RETURN
	END

	SUBROUTINE VENUS(BETA,RP,T)
C
C	VENUS CODE
C
	IMPLICIT REAL*8 (A-H,L,O-Z)
	IMPLICIT INTEGER*4 (I-K,M-N)
	COMMON /FMCMMN/ PLON,U,V,W,A1,A2,A3,A4,A5,A6,A7,A8,A9,
	1   A10,A11,A12,A13,A14,A15,A16,A17,A18,A19,A20,A21,A22,A23,
	1   A24,A25,A26,A27,A28,A29,A30,A31,A32,A33
	PLON = 2814*SIN(A13)-181*SIN(2*A14)-20*T*SIN(A13)
	BETA = 12215*SIN(A14)+83*SIN(A13+A14)+83*SIN(A13-A14)
	RP = 0.72335-0.00493*COS(A13)
	RETURN
	END
